--
--  File: c:\fernando\vhdl\acumulador\SRC\acumulador.VHD
--  created by Design Wizard: 10/17/98 18:41:05
--

library IEEE;
use IEEE.Std_Logic_1164.all;

package cleo is	
    subtype regsize is std_logic_vector(7 downto 0);		
	procedure somaAB  (  signal A,B: in  regsize;   signal Cin: in STD_LOGIC;
                         signal S:   out regsize;   signal Cout:out STD_LOGIC);
end cleo;

package body cleo is
     procedure somaAB  (  signal A,B:  in  regsize;  signal Cin:  in STD_LOGIC;
                         signal S:    out regsize;  signal Cout: out STD_LOGIC) is             
      variable carry : STD_LOGIC;
      begin	
		   for w in 0 to 7 loop
		        if w=0 then carry:=Cin;  end if;
				S(w) <= A(w) xor B(w) xor carry;
				carry := (A(w) and B(w)) or (A(w) and carry) or (B(w) and carry);
		   end loop;
		   Cout <= carry;
    	end somaAB;
end cleo;


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use work.cleo.all;

entity acumulador is
    port (
        reset: in STD_LOGIC;
        clock: in STD_LOGIC;
        saida: out STD_LOGIC_VECTOR (7 downto 0)
    );
end acumulador;

architecture acumulador of acumulador is
   
   signal soma, opA, opB : regsize;
   signal cin, cout : std_logic;

begin
  
  cin <= '0';				-- somador
  s1: somaAB( opA, opB, cin, soma, cout);
  
  saida <= soma;     -- conexo da sada do registrador  sada do circuito
  
  ---- registrador incrementador de 8 bits, com entrada e sada opA
  process (clock, reset)
  begin
    if RESET='1' then   opA <= (others=>'0');
        elsif (clock'event and clock='1') then  opA <= opA + 1;
    end if;
  end process;

  ---- registrador de 8 bits, com entrada soma e sada opB
  process (clock, reset)
  begin
    if RESET='1' then   opB <= (others=>'0');
        elsif (clock'event and clock='1') then  opB <= soma;
    end if;
  end process;
     
end acumulador;




library IEEE;
use IEEE.std_logic_1164.all;
use work.cleo.all;

	entity tb is
	end tb;

	architecture teste of tb is
	
	 component acumulador
      port (
         reset, clock: in STD_LOGIC;
         saida: out regsize
        );
  	  end component;
	
	signal reset, ck : std_logic;
	signal saida : regsize;
	
	begin
	
	   a1:  acumulador port map(clock=>ck, reset=>reset, saida=>saida);
	   
	   reset <= '1' , '0' after 10 ns;
	   -- gerador de clock
	   process
	    begin
	     ck <= '1' after 10ns, '0' after 20ns;
	     wait for 20ns;
	   end process;
	    
	end teste;
