library IEEE;
use IEEE.std_logic_1164.all;

entity MOORE is
	port(X, clock : in std_logic;  Z: out std_logic);
end;
architecture A of MOORE is
	type STATES is (K0, K1, K2, K3);
	signal scurrent, snext : STATES;
begin

	
   process(clock, scurrent, X)
	begin
	
	    if  clock'event and clock='1' then
		     scurrent <= snext;
		  end if;
		
		case scurrent is
			when K0 =>	Z <= '0';
						if X='0' then snext<=K0; else snext <= K2; end if;
			when K1 =>	Z <= '1';
						if X='0' then snext<=K0; else snext <= K2; end if;
			when K2 =>	Z <= '1';
						if X='0' then snext<=K2; else snext <= K3; end if;
			when K3 =>	Z <= '0';
						if X='0' then snext<=K3; else snext <= K1; end if;
		end case;
	end process;
end A;


architecture B of MOORE is
	type STATES is (S0, S1, S2, S3);
	signal scurrent, snext : STATES;
begin

	controle: process
	begin
		wait until clock'event and clock='1';
		scurrent <= snext;
	end process;

	combinacional: process(scurrent, X)
	begin
		case scurrent is
			when S0 =>	Z <= '0';
						if X='0' then snext<=S0; else snext <= S2; end if;
			when S1 =>	Z <= '1';
						if X='0' then snext<=S0; else snext <= S2; end if;
			when S2 =>	Z <= '1';
						if X='0' then snext<=S2; else snext <= S3; end if;
			when S3 =>	Z <= '0';
						if X='0' then snext<=S3; else snext <= S1; end if;
		end case;
	end process;
end B;



---------------------------------------------------------------
-----  test_bench
---------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

entity tb is
end tb;

architecture teste of tb is
	
	component MOORE
	    port(X, clock : in std_logic;  Z: out std_logic);
	end component;
	
	signal ck,X, saida : std_logic;
	
	begin
	
	   stm1:  MOORE port map(clock=>ck, X=>X, Z=>saida);
	   
	   X <= '0', '1' after 20ns, '0' after 50ns, '1' after 70ns, '0' after 130 ns ;
	   
	   -- gerador de clock
	   process
	    begin
	     ck <= '1' after 5ns, '0' after 10ns;
	     wait for 10ns;
	   end process;
	    
	end teste;
	
  

---
--- configuracao: diz qual das arquiteturas utilizar
---
configuration conf1 of tb is
     for teste
        for stm1 : MOORE

          use entity work.MOORE(A);   -- a1 seleciona Gray e a2 seleciona johnson

        end for;
     end for; 
end conf1;

